Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.openjpa.kernel
Class DelegatingFetchConfiguration

    java.lang.Object
      org.apache.openjpa.kernel.DelegatingFetchConfiguration

All Implemented Interfaces:
  Serializable, Cloneable, FetchConfiguration, LockLevels, LockScopes, QueryFlushModes

Direct Known Subclasses:
  DelegatingJDBCFetchConfiguration

    public class DelegatingFetchConfiguration

extends Object
implements FetchConfiguration

Delegating fetch configuration that can also perform exception translation for use in facades.

Author:
  Abe White
See Also:
  Serialized Form

Field Summary

Fields inherited from interface org.apache.openjpa.kernel.FetchConfiguration
`DEFAULT, FETCH_LOAD, FETCH_NONE, FETCH_REF`

Fields inherited from interface org.apache.openjpa.kernel.LockLevels
`LOCK_NONE, LOCK_READ, LOCK_WRITE`

Fields inherited from interface org.apache.openjpa.kernel.LockScopes
`LOCKSCOPE_EXTENDED, LOCKSCOPE_NORMAL`

Fields inherited from interface org.apache.openjpa.kernel.QueryFlushModes
`FLUSH_FALSE, FLUSH_TRUE, FLUSH_WITH_CONNECTION`

Constructor Summary
`DelegatingFetchConfiguration(FetchConfiguration fetch)` Constructor; supply delegate.
`DelegatingFetchConfiguration(FetchConfiguration fetch, RuntimeExceptionTranslator trans)` Constructor; supply delegate and exception translator.

Method Summary
`FetchConfiguration` | `addFetchGroup(String group)` Adds `group` to the set of fetch group names to use when loading objects.
`FetchConfiguration` | `addFetchGroups(Collection groups)` Adds `groups` to the set of fetch group names to use when loading objects.
`FetchConfiguration` | `addField(String field)` Adds `field` to the set of fully-qualified field names to use when loading objects.
`FetchConfiguration` | `addFields(Collection fields)` Adds `fields` to the set of fully-qualified field names to use when loading objects.
`FetchConfiguration` | `clearFetchGroups()` Clears the set of fetch group names to use when loading data.
`FetchConfiguration` | `clearFields()` Clears the set of field names to use when loading data.
`Object` | `clone()` Clone this instance.
`void` | `copy(FetchConfiguration fetch)` Copy the state from the given fetch configuration to this one.
`boolean` | `equals(Object other)`
`DataCacheRetrieveMode` | `getCacheRetrieveMode()` Gets the current retrieve mode for data cache.
`DataCacheStoreMode` | `getCacheStoreMode()` Gets the current storage mode for data cache.
`StoreContext` | `getContext()` Return the context associated with this configuration; may be null if it has not been set or this object has been serialized.
`FetchConfiguration` | `getDelegate()` Return the direct delegate.
`boolean` | `getExtendedPathLookup()` Affirms if extended path lookup feature is active.
`int` | `getFetchBatchSize()` Return the fetch batch size for large result set support.
`Set` | `getFetchGroups()` Returns immutable set of names of the fetch groups that this component will use when loading objects.
`Set` | `getFields()` Returns the set of fully-qualified field names that this component will use when loading objects.
`int` | `getFlushBeforeQueries()` The query automatic flush configuration.
`Object` | `getHint(String name)` Get the hint value for the specific key as originally set by the caller, or null if the hint is not specified.
`Map<String,Object>` | `getHints()` Get an immutable view of the currently active hints and their values.
`FetchConfiguration` | `getInnermostDelegate()` Return the native delegate.
`int` | `getLockScope()` The lock scope for next fetch.
`int` | `getLockTimeout()` The number of milliseconds to wait for an object lock, or -1 for no limit.
`int` | `getMaxFetchDepth()` Return the maximum depth of fetched instance graph.
`boolean` | `getQueryCacheEnabled()` Return whether or not query caching is enabled.
`int` | `getQueryTimeout()` The number of milliseconds to wait for a query, or -1 for no limit.
`int` | `getReadLockLevel()` The lock level to use for locking loaded objects.
`Set` | `getRootClasses()` Root classes for recursive operations.
`Set` | `getRootInstances()` Root instances for recursive operations.
`int` | `getWriteLockLevel()` The lock level to use for locking dirtied objects.
`boolean` | `hasFetchGroup(String group)` Return true if the given fetch group has been added.
`boolean` | `hasField(String field)` Return true if the given fully-qualified field has been added.
`int` | `hashCode()`
`boolean` | `isHintSet(String key)` Affirm if the given hint has been set in this receiver.
`void` | `lock()` Synchronize on internal lock if multithreaded is true.
`ResultList` | `newResultList(ResultObjectProvider rop)` Return a new result list for the current fetch configuration.
`FetchConfiguration` | `removeFetchGroup(String group)` Remove the given fetch group.
`FetchConfiguration` | `removeFetchGroups(Collection groups)` Removes `groups` from the set of fetch group names to use when loading objects.
`FetchConfiguration` | `removeField(String field)` Remove the given fully-qualified field.
`FetchConfiguration` | `removeFields(Collection fields)` Removes `fields` from the set of fully-qualified field names to use when loading objects.
`int` | `requiresFetch(FieldMetaData fmd)` Affirms if the given field requires to be fetched in the context of current fetch operation.
`boolean` | `requiresLoad()` Return false if we know that the object being fetched with this configuration does not require a load, because this configuration came from a traversal of a `FetchConfiguration.FETCH_REF` field.
`FetchConfiguration` | `resetFetchGroups()` Resets the set of fetch groups to the list in the global configuration.
`void` | `setCacheRetrieveMode(DataCacheRetrieveMode mode)` Sets the current retrieve mode for data cache.
`void` | `setCacheStoreMode(DataCacheStoreMode mode)` Sets the current storage mode for data cache.
`void` | `setContext(StoreContext ctx)` Called automatically by the system to associate the fetch configuration with a context before use.
`FetchConfiguration` | `setExtendedPathLookup(boolean flag)` Sets extended path lookup feature.
`FetchConfiguration` | `setFetchBatchSize(int fetchBatchSize)` Set the fetch batch size for large result set support.
`FetchConfiguration` | `setFlushBeforeQueries(int flush)` The query automatic flush configuration.
`void` | `setHint(String name, Object value)` Sets an arbitrary query hint that may be utilized during execution.
`void` | `setHint(String name, Object value, Object original)` Sets an arbitrary query hint that may be utilized during execution.
`FetchConfiguration` | `setLockScope(int scope)` The lock scope for next fetch.
`FetchConfiguration` | `setLockTimeout(int timeout)` The number of milliseconds to wait for an object lock, or -1 for no limit.
`FetchConfiguration` | `setMaxFetchDepth(int depth)` Set the maximum depth of the fetched instance graph.
`FetchConfiguration` | `setQueryCacheEnabled(boolean cache)` Control whether or not query caching is enabled.
`FetchConfiguration` | `setQueryTimeout(int timeout)` The number of milliseconds to wait for a query, or -1 for no limit.
`FetchConfiguration` | `setReadLockLevel(int level)` The lock level to use for locking loaded objects.
`FetchConfiguration` | `setRootClasses(Collection roots)` Root classes for recursive operations.
`FetchConfiguration` | `setRootInstances(Collection roots)` Root instances for recursive operations.
`FetchConfiguration` | `setWriteLockLevel(int level)` The lock level to use for locking dirtied objects.
`protected RuntimeException` | `translate(RuntimeException re)` Translate the OpenJPA exception.
`FetchConfiguration` | `traverse(FieldMetaData fmd)` Traverse the given field to generate (possibly) a new configuration state.
`void` | `unlock()` Release internal lock if multithreaded is true.

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DelegatingFetchConfiguration

    public DelegatingFetchConfiguration(FetchConfiguration fetch)

  Constructor; supply delegate.

### DelegatingFetchConfiguration

    public DelegatingFetchConfiguration(FetchConfiguration fetch,
                                        RuntimeExceptionTranslator trans)

  Constructor; supply delegate and exception translator.

Method Detail

### getDelegate

    public FetchConfiguration getDelegate()

  Return the direct delegate.

### getInnermostDelegate

    public FetchConfiguration getInnermostDelegate()

  Return the native delegate.

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### equals

    public boolean equals(Object other)

  Overrides:
    `equals` in class `Object`

### translate

    protected RuntimeException translate(RuntimeException re)

  Translate the OpenJPA exception.

### getContext

    public StoreContext getContext()

  Description copied from interface: `FetchConfiguration`
  Return the context associated with this configuration; may be null if it has not been set or this object has been serialized.

  Specified by:
    `getContext` in interface `FetchConfiguration`

### setContext

    public void setContext(StoreContext ctx)

  Description copied from interface: `FetchConfiguration`
  Called automatically by the system to associate the fetch configuration with a context before use. The fetch configuration properties should be synchronized with the context's configuration object. Subclasses for specific back ends cannot rely on the context's configuration implementing their back end's configuration sub-interface.

  Specified by:
    `setContext` in interface `FetchConfiguration`

### getFetchBatchSize

    public int getFetchBatchSize()

  Description copied from interface: `FetchConfiguration`
  Return the fetch batch size for large result set support. Defaults to the `openjpa.FetchBatchSize` setting. Note that this property will be ignored under some data stores.

  Specified by:
    `getFetchBatchSize` in interface `FetchConfiguration`

### setFetchBatchSize

    public FetchConfiguration setFetchBatchSize(int fetchBatchSize)

  Description copied from interface: `FetchConfiguration`
  Set the fetch batch size for large result set support. Defaults to the `openjpa.FetchBatchSize` setting. Note that this property will be ignored under some data stores.

  Specified by:
    `setFetchBatchSize` in interface `FetchConfiguration`

### getMaxFetchDepth

    public int getMaxFetchDepth()

  Description copied from interface: `FetchConfiguration`
  Return the maximum depth of fetched instance graph. Defaults to `1`

  Specified by:
    `getMaxFetchDepth` in interface `FetchConfiguration`

### setMaxFetchDepth

    public FetchConfiguration setMaxFetchDepth(int depth)

  Description copied from interface: `FetchConfiguration`
  Set the maximum depth of the fetched instance graph.

  Specified by:
    `setMaxFetchDepth` in interface `FetchConfiguration`
  Parameters:
    `depth` - denotes limiting length of traversal path from a root instance. `-1` implies no limit. `0` is not permissible.

### getRootInstances

    public Set getRootInstances()

  Description copied from interface: `FetchConfiguration`
  Root instances for recursive operations. This set is not thread safe.

  Specified by:
    `getRootInstances` in interface `FetchConfiguration`

### setRootInstances

    public FetchConfiguration setRootInstances(Collection roots)

  Description copied from interface: `FetchConfiguration`
  Root instances for recursive operations.

  Specified by:
    `setRootInstances` in interface `FetchConfiguration`

### getRootClasses

    public Set getRootClasses()

  Description copied from interface: `FetchConfiguration`
  Root classes for recursive operations. This set is not thread safe.

  Specified by:
    `getRootClasses` in interface `FetchConfiguration`

### setRootClasses

    public FetchConfiguration setRootClasses(Collection roots)

  Description copied from interface: `FetchConfiguration`
  Root classes for recursive operations.

  Specified by:
    `setRootClasses` in interface `FetchConfiguration`

### getQueryCacheEnabled

    public boolean getQueryCacheEnabled()

  Description copied from interface: `FetchConfiguration`
  Return whether or not query caching is enabled. If this returns `true` but the datacache plugin is not installed, caching will not be enabled. If this returns `false`, query caching will not be used even if the datacache plugin is installed.

  Specified by:
    `getQueryCacheEnabled` in interface `FetchConfiguration`

### setQueryCacheEnabled

    public FetchConfiguration setQueryCacheEnabled(boolean cache)

  Description copied from interface: `FetchConfiguration`
  Control whether or not query caching is enabled. This has no effect if the datacache plugin is not installed, or if the query cache size is set to zero.

  Specified by:
    `setQueryCacheEnabled` in interface `FetchConfiguration`

### getFlushBeforeQueries

    public int getFlushBeforeQueries()

  Description copied from interface: `FetchConfiguration`
  The query automatic flush configuration.

  Specified by:
    `getFlushBeforeQueries` in interface `FetchConfiguration`

### setFlushBeforeQueries

    public FetchConfiguration setFlushBeforeQueries(int flush)

  Description copied from interface: `FetchConfiguration`
  The query automatic flush configuration.

  Specified by:
    `setFlushBeforeQueries` in interface `FetchConfiguration`

### getExtendedPathLookup

    public boolean getExtendedPathLookup()

  Description copied from interface: `FetchConfiguration`
  Affirms if extended path lookup feature is active.

  Specified by:
    `getExtendedPathLookup` in interface `FetchConfiguration`

### setExtendedPathLookup

    public FetchConfiguration setExtendedPathLookup(boolean flag)

  Description copied from interface: `FetchConfiguration`
  Sets extended path lookup feature.

  Specified by:
    `setExtendedPathLookup` in interface `FetchConfiguration`

### getFetchGroups

    public Set getFetchGroups()

  Description copied from interface: `FetchConfiguration`
  Returns immutable set of names of the fetch groups that this component will use when loading objects. Defaults to the `openjpa.FetchGroups` setting. This set is not thread safe.

  Specified by:
    `getFetchGroups` in interface `FetchConfiguration`

### hasFetchGroup

    public boolean hasFetchGroup(String group)

  Description copied from interface: `FetchConfiguration`
  Return true if the given fetch group has been added.

  Specified by:
    `hasFetchGroup` in interface `FetchConfiguration`

### addFetchGroup

    public FetchConfiguration addFetchGroup(String group)

  Description copied from interface: `FetchConfiguration`
  Adds `group` to the set of fetch group names to use when loading objects.

  Specified by:
    `addFetchGroup` in interface `FetchConfiguration`

### addFetchGroups

    public FetchConfiguration addFetchGroups(Collection groups)

  Description copied from interface: `FetchConfiguration`
  Adds `groups` to the set of fetch group names to use when loading objects.

  Specified by:
    `addFetchGroups` in interface `FetchConfiguration`

### removeFetchGroup

    public FetchConfiguration removeFetchGroup(String group)

  Description copied from interface: `FetchConfiguration`
  Remove the given fetch group.

  Specified by:
    `removeFetchGroup` in interface `FetchConfiguration`

### removeFetchGroups

    public FetchConfiguration removeFetchGroups(Collection groups)

  Description copied from interface: `FetchConfiguration`
  Removes `groups` from the set of fetch group names to use when loading objects.

  Specified by:
    `removeFetchGroups` in interface `FetchConfiguration`

### clearFetchGroups

    public FetchConfiguration clearFetchGroups()

  Description copied from interface: `FetchConfiguration`
  Clears the set of fetch group names to use when loading data. After this operation is invoked, only those fields in the default fetch group (and any requested field) will be loaded when loading an object.

  Specified by:
    `clearFetchGroups` in interface `FetchConfiguration`

### resetFetchGroups

    public FetchConfiguration resetFetchGroups()

  Description copied from interface: `FetchConfiguration`
  Resets the set of fetch groups to the list in the global configuration.

  Specified by:
    `resetFetchGroups` in interface `FetchConfiguration`

### getFields

    public Set getFields()

  Description copied from interface: `FetchConfiguration`
  Returns the set of fully-qualified field names that this component will use when loading objects. Defaults to the empty set. This set is not thread safe.

  Specified by:
    `getFields` in interface `FetchConfiguration`

### hasField

    public boolean hasField(String field)

  Description copied from interface: `FetchConfiguration`
  Return true if the given fully-qualified field has been added.

  Specified by:
    `hasField` in interface `FetchConfiguration`

### addField

    public FetchConfiguration addField(String field)

  Description copied from interface: `FetchConfiguration`
  Adds `field` to the set of fully-qualified field names to use when loading objects.

  Specified by:
    `addField` in interface `FetchConfiguration`

### addFields

    public FetchConfiguration addFields(Collection fields)

  Description copied from interface: `FetchConfiguration`
  Adds `fields` to the set of fully-qualified field names to use when loading objects.

  Specified by:
    `addFields` in interface `FetchConfiguration`

### removeField

    public FetchConfiguration removeField(String field)

  Description copied from interface: `FetchConfiguration`
  Remove the given fully-qualified field.

  Specified by:
    `removeField` in interface `FetchConfiguration`

### removeFields

    public FetchConfiguration removeFields(Collection fields)

  Description copied from interface: `FetchConfiguration`
  Removes `fields` from the set of fully-qualified field names to use when loading objects.

  Specified by:
    `removeFields` in interface `FetchConfiguration`

### clearFields

    public FetchConfiguration clearFields()

  Description copied from interface: `FetchConfiguration`
  Clears the set of field names to use when loading data. After this operation is invoked, only those fields in the configured fetch groups will be loaded when loading an object.

  Specified by:
    `clearFields` in interface `FetchConfiguration`

### getLockTimeout

    public int getLockTimeout()

  Description copied from interface: `FetchConfiguration`
  The number of milliseconds to wait for an object lock, or -1 for no limit.

  Specified by:
    `getLockTimeout` in interface `FetchConfiguration`

### setLockTimeout

    public FetchConfiguration setLockTimeout(int timeout)

  Description copied from interface: `FetchConfiguration`
  The number of milliseconds to wait for an object lock, or -1 for no limit.

  Specified by:
    `setLockTimeout` in interface `FetchConfiguration`

### getQueryTimeout

    public int getQueryTimeout()

  Description copied from interface: `FetchConfiguration`
  The number of milliseconds to wait for a query, or -1 for no limit.

  Specified by:
    `getQueryTimeout` in interface `FetchConfiguration`

### setQueryTimeout

    public FetchConfiguration setQueryTimeout(int timeout)

  Description copied from interface: `FetchConfiguration`
  The number of milliseconds to wait for a query, or -1 for no limit.

  Specified by:
    `setQueryTimeout` in interface `FetchConfiguration`

### getLockScope

    public int getLockScope()

  Description copied from interface: `FetchConfiguration`
  The lock scope for next fetch.

  Specified by:
    `getLockScope` in interface `FetchConfiguration`

### setLockScope

    public FetchConfiguration setLockScope(int scope)

  Description copied from interface: `FetchConfiguration`
  The lock scope for next fetch.

  Specified by:
    `setLockScope` in interface `FetchConfiguration`

### getReadLockLevel

    public int getReadLockLevel()

  Description copied from interface: `FetchConfiguration`
  The lock level to use for locking loaded objects.

  Specified by:
    `getReadLockLevel` in interface `FetchConfiguration`

### setReadLockLevel

    public FetchConfiguration setReadLockLevel(int level)

  Description copied from interface: `FetchConfiguration`
  The lock level to use for locking loaded objects.

  Specified by:
    `setReadLockLevel` in interface `FetchConfiguration`

### getWriteLockLevel

    public int getWriteLockLevel()

  Description copied from interface: `FetchConfiguration`
  The lock level to use for locking dirtied objects.

  Specified by:
    `getWriteLockLevel` in interface `FetchConfiguration`

### setWriteLockLevel

    public FetchConfiguration setWriteLockLevel(int level)

  Description copied from interface: `FetchConfiguration`
  The lock level to use for locking dirtied objects.

  Specified by:
    `setWriteLockLevel` in interface `FetchConfiguration`

### newResultList

    public ResultList newResultList(ResultObjectProvider rop)

  Description copied from interface: `FetchConfiguration`
  Return a new result list for the current fetch configuration.

  Specified by:
    `newResultList` in interface `FetchConfiguration`

### copy

    public void copy(FetchConfiguration fetch)

  Description copied from interface: `FetchConfiguration`
  Copy the state from the given fetch configuration to this one.

  Specified by:
    `copy` in interface `FetchConfiguration`

### clone

    public Object clone()

  Description copied from interface: `FetchConfiguration`
  Clone this instance.

  Specified by:
    `clone` in interface `FetchConfiguration`
  Overrides:
    `clone` in class `Object`

### setHint

    public void setHint(String name,
                        Object value)

  Description copied from interface: `FetchConfiguration`
  Sets an arbitrary query hint that may be utilized during execution. The hint may be specific to a particular database. A hint, if known to this receiver, may have a corresponding setter method, then the hint sets the value. Otherwise the hint is stored opaquely by the receiver.
  This is same as calling FetchConfiguration.setHint(String, Object, Object) with the third argument being the same as the second.

  Specified by:
    `setHint` in interface `FetchConfiguration`
    `value` - the value of the hint. If the hint has a corresponding setter, then the type of value must be same as the setter argument.

### setHint

    public void setHint(String name,
                        Object value,
                        Object original)

  Description copied from interface: `FetchConfiguration`
  Sets an arbitrary query hint that may be utilized during execution. The hint may be specific to a particular database. A hint, if known to this receiver, may have a corresponding setter method, then the hint sets the value. Otherwise the hint is stored opaquely by the receiver.

  Specified by:
    `setHint` in interface `FetchConfiguration`
  Parameters:
    `name` - the name of the hint
    `value` - the value of the hint. If the hint has a corresponding setter, then the type of value must be same as the setter argument.
    `original` - the value of the hint as specified by the user.

### isHintSet

    public boolean isHintSet(String key)

  Description copied from interface: `FetchConfiguration`
  Affirm if the given hint has been set in this receiver.

  Specified by:
    `isHintSet` in interface `FetchConfiguration`

### getHint

    public Object getHint(String name)

  Description copied from interface: `FetchConfiguration`
  Get the hint value for the specific key as originally set by the caller, or null if the hint is not specified.

  Specified by:
    `getHint` in interface `FetchConfiguration`

### getHints

    public Map<String,Object> getHints()

  Description copied from interface: `FetchConfiguration`
  Get an immutable view of the currently active hints and their values. The values are as specified by the user.

  Specified by:
    `getHints` in interface `FetchConfiguration`

### requiresFetch

    public int requiresFetch(FieldMetaData fmd)

  Description copied from interface: `FetchConfiguration`
  Affirms if the given field requires to be fetched in the context of current fetch operation. Returns one of `FetchConfiguration.FETCH_NONE`, `FetchConfiguration.FETCH_LOAD`, `FETCH_REF`.

  Specified by:
    `requiresFetch` in interface `FetchConfiguration`

### requiresLoad

    public boolean requiresLoad()

  Description copied from interface: `FetchConfiguration`
  Return false if we know that the object being fetched with this configuration does not require a load, because this configuration came from a traversal of a `FetchConfiguration.FETCH_REF` field.

  Specified by:
    `requiresLoad` in interface `FetchConfiguration`

### traverse

    public FetchConfiguration traverse(FieldMetaData fmd)

  Description copied from interface: `FetchConfiguration`
  Traverse the given field to generate (possibly) a new configuration state.

  Specified by:
    `traverse` in interface `FetchConfiguration`
  Returns:
    a new configuration state resulting out of traversal

### lock

    public void lock()

  Description copied from interface: `FetchConfiguration`
  Synchronize on internal lock if multithreaded is true.

  Specified by:
    `lock` in interface `FetchConfiguration`

### unlock

    public void unlock()

  Description copied from interface: `FetchConfiguration`
  Release internal lock if multithreaded is true.

  Specified by:
    `unlock` in interface `FetchConfiguration`

### getCacheRetrieveMode

    public DataCacheRetrieveMode getCacheRetrieveMode()

  Description copied from interface: `FetchConfiguration`
  Gets the current retrieve mode for data cache.

  Specified by:
    `getCacheRetrieveMode` in interface `FetchConfiguration`

### getCacheStoreMode

    public DataCacheStoreMode getCacheStoreMode()

  Description copied from interface: `FetchConfiguration`
  Gets the current storage mode for data cache.

  Specified by:
    `getCacheStoreMode` in interface `FetchConfiguration`

### setCacheRetrieveMode

    public void setCacheRetrieveMode(DataCacheRetrieveMode mode)

  Description copied from interface: `FetchConfiguration`
  Sets the current retrieve mode for data cache.

  Specified by:
    `setCacheRetrieveMode` in interface `FetchConfiguration`

### setCacheStoreMode

    public void setCacheStoreMode(DataCacheStoreMode mode)

  Description copied from interface: `FetchConfiguration`
  Sets the current storage mode for data cache.

  Specified by:
    `setCacheStoreMode` in interface `FetchConfiguration`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 Apache Software Foundation. All Rights Reserved.